#include <stdio.h>
#include "oled.h"
#include "log.h"
#include "tool.h"
#include "t_oled.h"
#include "sim_oled.h"
#include <windows.h>
#include <process.h>
#include "key.h"
#include "sim_key.h"
uint8_t Cmd(uint8_t *data, size_t l) {
//    Buf_Print("Cmd", data, l, 16);
}

uint8_t Data(uint8_t *data, size_t l) {
//    Buf_Print("Data", data, l, 16);
}

void Refresh_Call(OLED_T *dev) {
//    LOGT("OLED", "CALL");
//    Buf_Print("Buf", dev->buf, dev->width * (dev->height / 8), 128);
    SIM_OLED_DrawFromBuffer(dev->buf, dev->width, dev->height / 8);
}

uint8_t oledbuf[8][128] = {0};

void Key_Call_E(Key_t *key) {
    switch (key->event) {
        case KEY_PRESS_DOWN:
            LOGT("KEY", "ID:%d EVENT:%s", key->key_id, "PressTheEvent");
            break;// 按下事件
        case KEY_PRESS_UP:
            LOGT("KEY", "ID:%d EVENT:%s", key->key_id, "BounceIncident");
            break;// 弹起事件
        case KEY_PRESS_REPEAT:
            LOGT("KEY", "ID:%d EVENT:%s", key->key_id, "RepeatThePressEvent");
            break;// 重复按下事件
        case KEY_SINGLE_CLICK:
            LOGT("KEY", "ID:%d EVENT:%s", key->key_id, "ClickEvent");
            break;// 单击事件
        case KEY_DOUBLE_CLICK:
            LOGT("KEY", "ID:%d EVENT:%s", key->key_id, "DoubleClickTheEvent");
            break;// 双击事件
        case KEY_LONG_PRESS_START:
            LOGT("KEY", "ID:%d EVENT:%s", key->key_id, "LongPressToStartTheEvent");
            break;// 长按开始事件
        case KEY_LONG_PRESS_HOLD:
            LOGT("KEY", "ID:%d EVENT:%s", key->key_id, "LongPressToHoldTheEvent");
            break;// 长按保持事件
    }
}

void Get_Key(void *pVoid) {
    Key_t k1, k2, k3, k4, k5, k6, k7;
    key_init(&k1, SIM_Key_UP, 1, SIM_KEY_UP);
    key_init(&k2, SIM_Key_DOWN, 1, SIM_KEY_DOWN);
    key_init(&k3, SIM_Key_LEFT, 1, SIM_KEY_LEFT);
    key_init(&k4, SIM_Key_RIGHT, 1, SIM_KEY_RIGHT);
    key_init(&k5, SIM_Key_ENABLE, 1, SIM_KEY_ENABLE);
    key_init(&k6, SIM_Key_SET, 1, SIM_KEY_SET);
    key_init(&k7, SIM_Key_RESET, 1, SIM_KEY_RESET);

    key_attach(&k1, KEY_ALL_EVENT, Key_Call_E);
    key_attach(&k2, KEY_ALL_EVENT, Key_Call_E);
    key_attach(&k3, KEY_ALL_EVENT, Key_Call_E);
    key_attach(&k4, KEY_ALL_EVENT, Key_Call_E);
    key_attach(&k5, KEY_ALL_EVENT, Key_Call_E);
    key_attach(&k6, KEY_ALL_EVENT, Key_Call_E);
    key_attach(&k7, KEY_ALL_EVENT, Key_Call_E);

    key_start(&k1);
    key_start(&k2);
    key_start(&k3);
    key_start(&k4);
    key_start(&k5);
    key_start(&k6);
    key_start(&k7);
    while (1) {
        // 每5ms调用一次key_ticks函数
        key_ticks();
        Sleep(5);
    }
    _endthread();
}

void Test_OLED() {
    SIM_OLED_INIT(128, 64, CYAN, 0x0, 5, 0);
    OLED_T oled = {
            .height=64,
            .width=128,
            .state=IDLE,
            .buf=oledbuf,
            .cmd=Cmd,
            .data=Data,
            .call=Refresh_Call,
    };
    OLED_Init(&oled);
    OLED_CLS(&oled);
//    OLED_DrawRect(&oled, 0, 0, 127, 63);
    OLED_ShowString(&oled, 32, 0, "Main Page", 12);
    OLED_ShowString(&oled, 36, 12, "1.PageA", 12);
    OLED_ShowString(&oled, 36, 24, "2.PageB", 12);
    OLED_ShowString(&oled, 36, 36, "3.PageC", 12);
    SIM_OLED_START();
    int s = 0;
    char buf[30];
    _beginthread(Get_Key, 0, NULL);
    while (1) {
        sprintf(buf, "DATA:%d", s);
        OLED_ShowString(&oled, 2, 51, buf, 12);
        OLED_Refresh(&oled);
        s++;
        Sleep(500);
    }
    SIM_OLED_STOP();
}